## msgpack-c 2.1.5

=== example/CMakeLists.txt ===
ADD_SUBDIRECTORY (c)
ADD_SUBDIRECTORY (cpp03)
ADD_SUBDIRECTORY (cpp11)
ADD_SUBDIRECTORY (boost)
ADD_SUBDIRECTORY (x3)

=== test/CMakeLists.txt ===
FIND_PACKAGE (GTest REQUIRED)
FIND_PACKAGE (ZLIB REQUIRED)
FIND_PACKAGE (Threads REQUIRED)

INCLUDE_DIRECTORIES (
    ${GTEST_INCLUDE_DIRS}
    ${ZLIB_INCLUDE_DIRS}
)

LIST (APPEND check_PROGRAMS
    array_ref.cpp
    buffer.cpp
    carray.cpp
    cases.cpp
    convert.cpp
    fixint.cpp
    fixint_c.cpp
    inc_adaptor_define.cpp
    json.cpp
    limit.cpp
    msgpack_basic.cpp
    msgpack_c.cpp
    msgpack_container.cpp
    msgpack_stream.cpp
    msgpack_tuple.cpp
    msgpack_vref.cpp
    object.cpp
    object_with_zone.cpp
    pack_unpack.cpp
    pack_unpack_c.cpp
    raw.cpp
    reference.cpp
    size_equal_only.cpp
    streaming.cpp
    streaming_c.cpp
    user_class.cpp
    version.cpp
    visitor.cpp
    zone.cpp
)

IF (MSGPACK_BOOST)
    LIST (APPEND check_PROGRAMS
        boost_fusion.cpp
        boost_variant.cpp
        boost_optional.cpp
        boost_string_ref.cpp
        boost_string_view.cpp
    )
ENDIF ()

IF (MSGPACK_USE_X3_PARSE)
    LIST (APPEND check_PROGRAMS
        msgpack_x3_parse.cpp
    )
ENDIF ()

IF (MSGPACK_CXX11)
    LIST (APPEND check_PROGRAMS
        iterator_cpp11.cpp
        msgpack_cpp11.cpp
        reference_cpp11.cpp
        reference_wrapper_cpp11.cpp
        shared_ptr_cpp11.cpp
        unique_ptr_cpp11.cpp
    )
ENDIF ()

IF (MSGPACK_CXX17)
    LIST (APPEND check_PROGRAMS
        msgpack_cpp17.cpp
    )
ENDIF ()

FOREACH (source_file ${check_PROGRAMS})
    GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
    ADD_EXECUTABLE (
        ${source_file_we}
        ${source_file}
    )
    TARGET_LINK_LIBRARIES (${source_file_we}
        msgpackc
        ${GTEST_BOTH_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
    )
    ADD_TEST (${source_file_we} ${source_file_we})
    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS "-Wall -Wextra -Werror -g -O3 ")
    ENDIF ()
    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
    ENDIF ()

    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
        IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4] /WX")
            STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        ELSE ()
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3")
        ENDIF ()
    ENDIF ()
ENDFOREACH ()

ADD_EXECUTABLE (
    multi_file
    multi_file1.cpp multi_file2.cpp
)
TARGET_INCLUDE_DIRECTORIES (multi_file
    PRIVATE
        $<TARGET_PROPERTY:msgpackc,INTERFACE_INCLUDE_DIRECTORIES>
)
ADD_TEST (multi_file multi_file)

=== example/c/CMakeLists.txt ===
IF (MSGPACK_ENABLE_SHARED)
    SET (MSGPACK_LIB msgpackc)
ELSE ()
    SET (MSGPACK_LIB msgpackc-static)
ENDIF ()


LIST (APPEND exec_PROGRAMS
    lib_buffer_unpack.c
    simple_c.c
    speed_test_uint32_array.c
    speed_test_uint64_array.c
    user_buffer_unpack.c
)

FOREACH (source_file ${exec_PROGRAMS})
    GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
    ADD_EXECUTABLE (
        ${source_file_we}
        ${source_file}
    )
    TARGET_LINK_LIBRARIES (${source_file_we}
        ${MSGPACK_LIB}
    )
    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS "-Wall -Wextra -Werror -g -O3")
    ENDIF ()

    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
    ENDIF ()

    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
        IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
            STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        ELSE ()
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
        ENDIF ()
    ENDIF ()
ENDFOREACH ()

=== example/cpp11/CMakeLists.txt ===
IF (MSGPACK_CXX11)
    INCLUDE_DIRECTORIES (
        ../include
    )

    LIST (APPEND exec_PROGRAMS
        container.cpp
        non_def_con_class.cpp
    )

    IF ("${MSGPACK_DEFAULT_API_VERSION}" GREATER "1")
        LIST (APPEND exec_PROGRAMS
            socket_stream_example.cpp
        )
    ENDIF ()

    FOREACH (source_file ${exec_PROGRAMS})
        GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
        ADD_EXECUTABLE (
            ${source_file_we}
            ${source_file}
        )
        TARGET_INCLUDE_DIRECTORIES (${source_file_we}
            PRIVATE
                $<TARGET_PROPERTY:msgpackc,INTERFACE_INCLUDE_DIRECTORIES>
        )
        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
            SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS "-Wall -Wextra -Werror -g -O3 ")
        ENDIF ()

        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
            SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
        ENDIF ()

        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
            IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
                STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
            ELSE ()
                SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
            ENDIF ()
        ENDIF ()
    ENDFOREACH ()
ENDIF ()

## msgpack-c 1.4.2

=== debian/changelog ===
msgpack-c (1.4.2-4) unstable; urgency=medium

  * Apply another upstream patch to fix FTBFS on sparc64.

 -- James McCoy <jamessan@debian.org>  Sat, 17 Sep 2016 13:53:14 -0400

msgpack-c (1.4.2-3) unstable; urgency=medium

  * Upload to unstable

 -- James McCoy <jamessan@debian.org>  Fri, 02 Sep 2016 21:52:39 -0400

msgpack-c (1.4.2-2) experimental; urgency=medium

  * Apply upstream patch to fix FTBFS on sparc64.

 -- James McCoy <jamessan@debian.org>  Thu, 21 Jul 2016 23:00:26 -0400

msgpack-c (1.4.2-1) experimental; urgency=medium

  * New upstream release
    + Fix FTBFS with gcc6

 -- James McCoy <jamessan@debian.org>  Tue, 28 Jun 2016 21:51:41 -0400

msgpack-c (1.4.0-2) experimental; urgency=medium

  * Bump minimum symbols version of APIs which deal with the object types.
    (Closes: #814096)

 -- James McCoy <jamessan@debian.org>  Sun, 14 Feb 2016 15:07:31 -0500

msgpack-c (1.4.0-1) experimental; urgency=medium

  * New upstream release
    + libmsgpack.so no longer exists, since the C++ code is header-only.
      libmsgpackc.so is the C library.
  * Remove libmsgpack4 package.
  * Build and include documentation in libmsgpack-doc

 -- James McCoy <jamessan@debian.org>  Sat, 23 Jan 2016 02:12:45 -0500

msgpack-c (1.3.0-3) experimental; urgency=medium

  * Cherry-pick upstream patch to fix FTBFS on big-endian architectures.

 -- James McCoy <jamessan@debian.org>  Fri, 15 Jan 2016 20:56:59 -0500

msgpack-c (1.3.0-2) experimental; urgency=medium

  * Cherry-pick upstream patch to fix FTBFS when “char” is unsigned.
  * Enable all hardening build flags.

 -- James McCoy <jamessan@debian.org>  Wed, 13 Jan 2016 20:03:40 -0500

msgpack-c (1.3.0-1) experimental; urgency=medium

  * New upstream release
    + Fix FTBFS on ARM (Closes: #749079)
    + License change from Apache 2.0 to Boost Software License 1.0
    + Support for msgpack v5 format
    + C++11 support
    + Rewritten README with current links to msgpack information.  (Closes:
      #703657)
  * Point watch file to GitHub releases.
  * Bump debhelper compat to 9
  * Switch from cdbs to dh
    + Use autotools-dev addon to update config.{sub,guess}.  (Closes: #734569)
  * Add libgtest-dev and zlib1g-dev to Build-Depends, so the test suite can be
    run.
  * Enable C++11 support
  * Mark libmsgpack4 and libmsgpackc2 as Multi-Arch: same
  * Declare compliance with policy 3.9.6
  * Include msgpack.pc in libmsgpack-dev

 -- James McCoy <jamessan@debian.org>  Sun, 10 Jan 2016 22:45:48 -0500

msgpack (0.5.7-3) unstable; urgency=low

  * Migration from Subversion to Git
  * Bump Standards-Version to 3.9.4.

 -- Taku YASUI <tach@debian.org>  Fri, 16 Aug 2013 18:13:02 +0900

msgpack (0.5.7-2) unstable; urgency=low

  * Fix big-endian problem
    - Add patch 20_fix_bigendian
      https://github.com/msgpack/msgpack/commit/b8aa93ce30d11d091b339bff0e10ddf3a8d08daf

 -- Taku YASUI <tach@debian.org>  Mon, 16 Apr 2012 03:23:53 +0900

msgpack (0.5.7-1) unstable; urgency=low

  * New upstream release
  * Remove needless README.source
  * Move repository to svn.debian.org
    - Vcs-Svn: svn://svn.debian.org/svn/collab-maint/deb-maint/msgpack
  * Bump Standards-Version to 3.9.3

 -- Taku YASUI <tach@debian.org>  Sat, 31 Mar 2012 05:53:02 +0900

msgpack (0.5.4-2) unstable; urgency=low

  * Remove *.la file from libmsgpack-dev (closes: #622438)
  * Change Standard-Version to 3.9.2

 -- Taku YASUI <tach@debian.org>  Sat, 18 Jun 2011 12:31:24 +0900

msgpack (0.5.4-1) unstable; urgency=low

  * New upstream release

 -- Taku YASUI <tach@debian.org>  Fri, 10 Sep 2010 23:49:13 +0900

msgpack (0.5.1-1) unstable; urgency=low

  * Initial release (closes: #588387)

 -- Taku YASUI <tach@debian.org>  Mon, 12 Jul 2010 02:27:55 +0900

=== debian/control ===
Source: msgpack-c
Section: libs
Priority: extra
Maintainer: Taku YASUI <tach@debian.org>
Uploaders: James McCoy <jamessan@debian.org>
Build-Depends-Indep: doxygen,
                     doxygen-latex
Build-Depends: autoconf,
               automake,
               autotools-dev,
               cmake,
               debhelper (>= 9),
               libgtest-dev,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: https://github.com/msgpack/msgpack-c/
Vcs-Git: https://anonscm.debian.org/git/collab-maint/msgpack-c.git
Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/msgpack-c.git

Package: libmsgpackc2
Pre-Depends: ${misc:Pre-Depends}
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: binary-based efficient object serialization library
 MessagePack is a binary-based efficient object serialization library.
 It enables to exchange structured objects between many languages like JSON.
 But unlike JSON, it is very fast and small.

Package: libmsgpack-dev
Section: libdevel
Architecture: any
Depends: libmsgpackc2 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libmsgpack-doc
Description: binary-based efficient object serialization library
 MessagePack is a binary-based efficient object serialization library.
 It enables to exchange structured objects between many languages like JSON.
 But unlike JSON, it is very fast and small.
 .
 This package contains the headers files needed for developing with msgpack-c.

Package: libmsgpack-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: binary-based efficient object serialization library (docs)
 MessagePack is a binary-based efficient object serialization library.
 It enables to exchange structured objects between many languages like JSON.
 But unlike JSON, it is very fast and small.
 .
 This package contains the documentation of msgpack-c's API.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
include /usr/share/dpkg/buildflags.mk

CXXFLAGS += -std=c++11
export CFLAGS CXXFLAGS LDFLAGS

%:
	dh $@ --with=autotools_dev --parallel --buildsystem=autoconf

override_dh_auto_build-indep:
	make -C src doxygen

override_dh_install-indep:
	dh_install -i
	dh_doxygen

override_dh_auto_test-indep:

override_dh_auto_test:
	mkdir -p build-gtest
	cd build-gtest && cmake -Wno-dev /usr/src/gtest && make
	dh_auto_test --parallel --buildsystem=autoconf -- LDFLAGS="$(LDFLAGS) -L$(CURDIR)/build-gtest"

override_dh_install:
	dh_install --list-missing

## msgpack-c 2.1.5

=== debian/changelog ===
msgpack-c (2.1.5-2) unstable; urgency=medium

  * control:
    + Change Vcs-* to salsa.debian.org
    + Declare compliance with Policy 4.1.3
    + Set myself as maintainer.  Thanks to Taku YASUI for all his work on the
      package
    + Set Rules-Requires-Root to no
  * Bump debhelper compat to 11
  * Install doxygen docs using dh_installdocs
  * rules: Remove -pie from hardening build options for dpkg >= 1.18.23
  * Stop installing duplicate copy of upstream README
  * Register API documentation with doc-base

 -- James McCoy <jamessan@debian.org>  Wed, 28 Mar 2018 21:07:03 -0400

msgpack-c (2.1.5-1) unstable; urgency=medium

  * New upstream release
  * Upload to unstable
  * Declare compliance with Policy 4.1.0
    + Change Priority from extra to optional

 -- James McCoy <jamessan@debian.org>  Sun, 17 Sep 2017 08:53:26 -0400

msgpack-c (2.1.3-1) experimental; urgency=medium

  * New upstream release
    + Fix FTBFS with gcc-7 (Closes: #853564)
    + Bump minimum CMake version to 2.8.12
    + Provide CMake config files to assist building against msgpack-c.

 -- James McCoy <jamessan@debian.org>  Sun, 18 Jun 2017 22:15:47 -0400

msgpack-c (2.1.1-1) experimental; urgency=medium

  * New upstream release (Closes: #845066)
    + Incompatible changes in v2 API
      - Removed pointer versions of msgpack::unpack APIs.
      - Removed pointer versions of msgpack::convert APIs.
      - Removed msgpack::type::nil in favor of msgpack::type::nil_t.
      - Removed std::string specialization for msgpack::object conversion.
    + New FLOAT32/FLOAT64 object types, the latter of which is the same as the
      existing FLOAT type.
      - This also introduces explicit (un)pack functions that handle C's float
        instead of coercing them to double.
  * debian/rules: Rework to use CMake instead of autotools
  * Update symbols for new APIs/object types
  * Declare compliance with policy 3.9.8, no changes needed

 -- James McCoy <jamessan@debian.org>  Thu, 01 Jun 2017 23:59:45 -0400

msgpack-c (1.4.2-5) unstable; urgency=medium

  * Backport upstream patches to fix FTBFS with GCC-7. (Closes: #871140)

 -- James McCoy <jamessan@debian.org>  Mon, 21 Aug 2017 07:00:24 -0400

=== debian/control ===
--- 
+++ 
@@ -1,21 +1,18 @@
 Source: msgpack-c
 Section: libs
-Priority: extra
-Maintainer: Taku YASUI <tach@debian.org>
-Uploaders: James McCoy <jamessan@debian.org>
+Priority: optional
+Maintainer: James McCoy <jamessan@debian.org>
 Build-Depends-Indep: doxygen,
                      doxygen-latex
-Build-Depends: autoconf,
-               automake,
-               autotools-dev,
-               cmake,
-               debhelper (>= 9),
-               libgtest-dev,
+Build-Depends: cmake (>= 2.8.12),
+               debhelper (>= 11~),
+               googletest,
                zlib1g-dev
-Standards-Version: 3.9.6
+Standards-Version: 4.1.3
 Homepage: https://github.com/msgpack/msgpack-c/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/msgpack-c.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/msgpack-c.git
+Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/jamessan/msgpack-c.git
+Vcs-Browser: https://salsa.debian.org/jamessan/msgpack-c
 
 Package: libmsgpackc2
 Pre-Depends: ${misc:Pre-Depends}

=== debian/rules ===
#!/usr/bin/make -f

DPKG_VER = $(shell dpkg-query --show --showformat '$${source:Version}' dpkg-dev)

ifeq (yes,$(shell dpkg --compare-versions '$(DPKG_VER)' ge 1.18.23 && printf 'yes'))
  export DEB_BUILD_MAINT_OPTIONS=hardening=+all
else
  export DEB_BUILD_MAINT_OPTIONS=hardening=+all,-pie
endif
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk

export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS

%:
	dh $@ --builddirectory=build

override_dh_auto_configure:
	env GTEST_ROOT=/usr/src/googletest/googletest dh_auto_configure -- -DMSGPACK_CXX11=ON -DMSGPACK_ENABLE_SHARED=ON -DMSGPACK_ENABLE_CXX=ON -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_build-indep:
	dh_auto_build -- doxygen

override_dh_install-indep:
	dh_install -i
	dh_doxygen

override_dh_installdocs-indep:
	mkdir -p build/html
	mv build/doc_c/html build/html/msgpack-c
	mv build/doc_cpp/html build/html/msgpack-cpp
	dh_installdocs

override_dh_auto_test-indep:

override_dh_install:
	dh_install --list-missing

## msgpack-c 2.1.5-1+8.0trisquel1

=== debian/changelog ===
msgpack-c (2.1.5-1+8.0trisquel1) flidas; urgency=medium

  * Backported from bionic

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Tue, 09 Oct 2018 01:25:41 +0000

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: msgpack-c
 Section: libs
 Priority: optional
-Maintainer: James McCoy <jamessan@debian.org>
+Maintainer: Taku YASUI <tach@debian.org>
+Uploaders: James McCoy <jamessan@debian.org>
 Build-Depends-Indep: doxygen,
                      doxygen-latex
 Build-Depends: cmake (>= 2.8.12),
-               debhelper (>= 11~),
-               googletest,
+               debhelper (>= 9),
                zlib1g-dev
-Standards-Version: 4.1.3
+Standards-Version: 3.9.8
 Homepage: https://github.com/msgpack/msgpack-c/
-Rules-Requires-Root: no
-Vcs-Git: https://salsa.debian.org/jamessan/msgpack-c.git
-Vcs-Browser: https://salsa.debian.org/jamessan/msgpack-c
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/msgpack-c.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/msgpack-c.git
 
 Package: libmsgpackc2
 Pre-Depends: ${misc:Pre-Depends}

## msgpack-c 3.0.0

=== debian/changelog ===
msgpack-c (3.0.0-1) unstable; urgency=medium

  * New upstream release
    + Fixes FTBFS with gcc8 (Closes: #897815)
    + New v3 C++ API
  * copyright: Bump years for debian/* and *
  * Declare compliance with Policy 4.1.4, no changes needed
  * control: Differentiate libmsgpack-dev short description from libmsgpackc2
  * Build/run some of upstream's examples as basic autopkgtests

 -- James McCoy <jamessan@debian.org>  Thu, 10 May 2018 23:08:20 -0400

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,18 @@
 Source: msgpack-c
 Section: libs
 Priority: optional
-Maintainer: Taku YASUI <tach@debian.org>
-Uploaders: James McCoy <jamessan@debian.org>
+Maintainer: James McCoy <jamessan@debian.org>
 Build-Depends-Indep: doxygen,
                      doxygen-latex
 Build-Depends: cmake (>= 2.8.12),
-               debhelper (>= 9),
+               debhelper (>= 11~),
+               googletest,
                zlib1g-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.4
 Homepage: https://github.com/msgpack/msgpack-c/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/msgpack-c.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/msgpack-c.git
+Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/jamessan/msgpack-c.git
+Vcs-Browser: https://salsa.debian.org/jamessan/msgpack-c
 
 Package: libmsgpackc2
 Pre-Depends: ${misc:Pre-Depends}
@@ -29,7 +30,7 @@
 Depends: libmsgpackc2 (= ${binary:Version}),
          ${misc:Depends}
 Suggests: libmsgpack-doc
-Description: binary-based efficient object serialization library
+Description: binary-based efficient object serialization library (development files)
  MessagePack is a binary-based efficient object serialization library.
  It enables to exchange structured objects between many languages like JSON.
  But unlike JSON, it is very fast and small.

## msgpack-c 3.0.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED (VERSION 2.8.12)

IF ((CMAKE_VERSION VERSION_GREATER 3.1) OR
    (CMAKE_VERSION VERSION_EQUAL 3.1))
    CMAKE_POLICY(SET CMP0054 NEW)
ENDIF ()

PROJECT (msgpack)

FILE (READ ${CMAKE_CURRENT_SOURCE_DIR}/include/msgpack/version_master.h contents)
STRING (REGEX MATCH "#define MSGPACK_VERSION_MAJOR *([0-9a-zA-Z_]*)" NULL_OUT ${contents})
SET (VERSION_MAJOR ${CMAKE_MATCH_1})
STRING (REGEX MATCH "#define MSGPACK_VERSION_MINOR *([0-9a-zA-Z_]*)" NULL_OUT ${contents})
SET (VERSION_MINOR ${CMAKE_MATCH_1})
STRING (REGEX MATCH "#define MSGPACK_VERSION_REVISION *([0-9a-zA-Z_]*)" NULL_OUT ${contents})
SET (VERSION_REVISION ${CMAKE_MATCH_1})
SET (VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_REVISION})

SET (prefix ${CMAKE_INSTALL_PREFIX})
SET (exec_prefix "\${prefix}")
SET (libdir "\${exec_prefix}/lib")
SET (includedir "\${prefix}/include")
SET (GNUCXX_STD_SUPPORT_VERSION "4.3")

OPTION (MSGPACK_CXX11 "Using c++11 compiler" OFF)
OPTION (MSGPACK_32BIT "32bit compile" OFF)
OPTION (MSGPACK_BOOST "Using boost libraries" OFF)

IF (APPLE)
    SET(CMAKE_MACOSX_RPATH ON)
    SET(CMAKE_SKIP_BUILD_RPATH FALSE)
    SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
    SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
    LIST(FIND CMAKE_PLATFORM_IMPLICIT_LINK_DIRECTORIES "${CMAKE_INSTALL_PREFIX}/lib" isSystemDir)
    IF ("${isSystemDir}" STREQUAL "-1")
        SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
    ENDIF ()
ENDIF ()

IF (MSGPACK_USE_X3_PARSE)
   IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
      SET (CMAKE_CXX_FLAGS "-DMSGPACK_USE_X3_PARSE -std=c++14 ${CMAKE_CXX_FLAGS}")
   ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
      SET (CMAKE_CXX_FLAGS "-DMSGPACK_USE_X3_PARSE -std=c++14 ${CMAKE_CXX_FLAGS}")
   ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
      SET (CMAKE_CXX_FLAGS "-DMSGPACK_USE_X3_PARSE ${CMAKE_CXX_FLAGS}")
      IF (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 19)
          MESSAGE ( FATAL_ERROR "MSVC doesn't support C++14.")
      ENDIF ()
   ENDIF ()
ELSE ()
   IF (MSGPACK_CXX17)
      IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
         SET (CMAKE_CXX_FLAGS "-std=c++17 ${CMAKE_CXX_FLAGS}")
      ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
         SET (CMAKE_CXX_FLAGS "-std=c++17 ${CMAKE_CXX_FLAGS}")
      ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
         MESSAGE ( FATAL_ERROR "MSVC doesn't support C++17.")
      ENDIF ()
   ELSEIF (MSGPACK_CXX11)
      IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
         SET (CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
      ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
         SET (CMAKE_CXX_FLAGS "-std=c++11 ${CMAKE_CXX_FLAGS}")
      ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
         IF (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 19)
             MESSAGE ( FATAL_ERROR "MSVC doesn't support C++11.")
         ENDIF ()
      ENDIF ()
   ELSE ()
      IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
         IF ((CMAKE_CXX_COMPILER_VERSION VERSION_GREATER ${GNUCXX_STD_SUPPORT_VERSION}) OR
             (CMAKE_CXX_COMPILER_VERSION VERSION_EQUAL   ${GNUCXX_STD_SUPPORT_VERSION}))
             SET (CMAKE_CXX_FLAGS "-std=c++98 ${CMAKE_CXX_FLAGS}")
         ENDIF ()
      ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
         SET (CMAKE_CXX_FLAGS "-std=c++98 ${CMAKE_CXX_FLAGS}")
      ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
         IF (CMAKE_CXX_COMPILER_VERSION VERSION_GREATER 18)
             SET (CMAKE_CXX_FLAGS "-DMSGPACK_USE_CPP03 ${CMAKE_CXX_FLAGS}")
         ENDIF ()
      ENDIF ()
   ENDIF ()
ENDIF ()

IF (MSGPACK_32BIT)
   IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
      SET (CMAKE_CXX_FLAGS "-m32 ${CMAKE_CXX_FLAGS}")
      SET (CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}")
      SET (CMAKE_EXE_LINKER_FLAGS "-m32 ${CMAKE_EXE_LINKER_FLAGS}")
   ELSEIF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
      SET (CMAKE_CXX_FLAGS "-m32 ${CMAKE_CXX_FLAGS}")
      SET (CMAKE_C_FLAGS "-m32 ${CMAKE_C_FLAGS}")
      SET (CMAKE_EXE_LINKER_FLAGS "-m32 ${CMAKE_EXE_LINKER_FLAGS}")
   ENDIF ()
ENDIF ()

OPTION (MSGPACK_BUILD_EXAMPLES "Build msgpack examples." ON)

IF (MSGPACK_BOOST)
   SET (CMAKE_CXX_FLAGS "-DMSGPACK_USE_BOOST ${CMAKE_CXX_FLAGS}")
   SET (Boost_USE_MULTITHREADED      ON)
   SET (Boost_USE_STATIC_RUNTIME    OFF)
   FIND_PACKAGE (Boost REQUIRED COMPONENTS chrono context system timer)
   INCLUDE_DIRECTORIES (
      ${Boost_INCLUDE_DIRS}
   )
   LINK_DIRECTORIES (
      ${Boost_LIBRARY_DIRS}
   )
   IF (MSGPACK_BOOST_DIR)
      INCLUDE_DIRECTORIES (
         ${MSGPACK_BOOST_DIR}
      )
   ENDIF ()
ENDIF ()

IF (MSGPACK_CHAR_SIGN)
   SET (CMAKE_C_FLAGS "-f${MSGPACK_CHAR_SIGN}-char ${CMAKE_C_FLAGS}")
   SET (CMAKE_CXX_FLAGS "-f${MSGPACK_CHAR_SIGN}-char ${CMAKE_CXX_FLAGS}")
ENDIF ()

IF (MSGPACK_DEFAULT_API_VERSION)
   SET (CMAKE_CXX_FLAGS "-DMSGPACK_DEFAULT_API_VERSION=${MSGPACK_DEFAULT_API_VERSION} ${CMAKE_CXX_FLAGS}")
ELSE ()
   SET (CMAKE_CXX_FLAGS "-DMSGPACK_DEFAULT_API_VERSION=3 ${CMAKE_CXX_FLAGS}")
ENDIF ()

FILE (GLOB_RECURSE PREDEF_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/external/boost/predef/include/boost ${CMAKE_CURRENT_SOURCE_DIR}/external/boost/predef/include/boost/*.h)
FOREACH (F ${PREDEF_FILES})
   SET(M "Converting ${F}")
   MESSAGE(STATUS ${M})
   FILE (READ ${CMAKE_CURRENT_SOURCE_DIR}/external/boost/predef/include/boost/${F} CONTENT)
   STRING(REPLACE "BOOST_" "MSGPACK_" CONTENT ${CONTENT})
   STRING(REPLACE "boost/" "msgpack/" CONTENT ${CONTENT})
   FILE (GENERATE OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/include/msgpack/${F} CONTENT ${CONTENT})
ENDFOREACH ()

FILE (GLOB_RECURSE PREPROCESSOR_FILES RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/external/boost/preprocessor/include/boost ${CMAKE_CURRENT_SOURCE_DIR}/external/boost/preprocessor/include/boost/*.hpp)
FOREACH (F ${PREPROCESSOR_FILES})
   SET(M "Converting ${F}")
   MESSAGE(STATUS ${M})
   FILE (READ ${CMAKE_CURRENT_SOURCE_DIR}/external/boost/preprocessor/include/boost/${F} CONTENT)
   STRING(REPLACE "BOOST_" "MSGPACK_" CONTENT ${CONTENT})
   STRING(REPLACE "boost/" "msgpack/" CONTENT ${CONTENT})
   FILE (GENERATE OUTPUT ${CMAKE_CURRENT_SOURCE_DIR}/include/msgpack/${F} CONTENT ${CONTENT})
ENDFOREACH ()

FIND_PACKAGE (GTest)
FIND_PACKAGE (ZLIB)
FIND_PACKAGE (Threads)
IF (GTEST_FOUND AND ZLIB_FOUND AND THREADS_FOUND)
    OPTION (MSGPACK_BUILD_TESTS "Build msgpack tests." ON)
ENDIF ()

OPTION (MSGPACK_ENABLE_CXX "Enable C++ interface." ON)
OPTION (MSGPACK_ENABLE_SHARED "Build shared libaries in addition to static libraries." ON)

INCLUDE (CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES ("
#include <bits/atomicity.h>
int atomic_sub(int i) { return __gnu_cxx::__exchange_and_add(&i, -1) - 1; }
int atomic_add(int i) { return __gnu_cxx::__exchange_and_add(&i, 1) + 1; }
int main(int argc, char * argv[])
{
    atomic_sub(1);
    atomic_add(1);
}
" MSGPACK_ENABLE_GCC_CXX_ATOMIC)

INCLUDE (Files.cmake)

EXECUTE_PROCESS (
    COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/src/msgpack
)

CONFIGURE_FILE (
    msgpack.pc.in
    msgpack.pc
    @ONLY
)

IF (MSGPACK_ENABLE_SHARED)
    ADD_LIBRARY (msgpackc SHARED
        ${msgpackc_SOURCES}
        ${msgpackc_HEADERS}
    )

    TARGET_INCLUDE_DIRECTORIES (msgpackc
        PUBLIC
            $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
            $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
            $<INSTALL_INTERFACE:include>
        PRIVATE
            ${CMAKE_CURRENT_SOURCE_DIR}
    )
ENDIF ()

ADD_LIBRARY (msgpackc-static STATIC
    ${msgpackc_SOURCES}
    ${msgpackc_HEADERS}
)

TARGET_INCLUDE_DIRECTORIES (msgpackc-static
    PUBLIC
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
        $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
        $<INSTALL_INTERFACE:include>
    PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}
)

IF (NOT MSGPACK_ENABLE_SHARED)
    # Add alias for subdirectories
    ADD_LIBRARY (msgpackc ALIAS msgpackc-static)
ENDIF ()

SET_TARGET_PROPERTIES (msgpackc-static PROPERTIES OUTPUT_NAME "msgpackc")
IF (MSGPACK_ENABLE_SHARED)
    IF (MSVC)
        SET_TARGET_PROPERTIES (msgpackc PROPERTIES IMPORT_SUFFIX "_import.lib")
    ELSEIF (MINGW)
        SET_TARGET_PROPERTIES (msgpackc PROPERTIES IMPORT_SUFFIX ".dll.a")
    ENDIF ()
    SET_TARGET_PROPERTIES (msgpackc PROPERTIES SOVERSION 2 VERSION 2.0.0)
ENDIF ()

IF (MSGPACK_BUILD_TESTS)
    ENABLE_TESTING ()
    # MEMORYCHECK_COMMAND_OPTIONS needs to place prior to CTEST_MEMORYCHECK_COMMAND
    SET (MEMORYCHECK_COMMAND_OPTIONS "--leak-check=full --show-leak-kinds=definite,possible --error-exitcode=1")
    FIND_PROGRAM(CTEST_MEMORYCHECK_COMMAND NAMES valgrind)
    INCLUDE(Dart)
    ADD_SUBDIRECTORY (test)
ENDIF ()

IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
    IF (MSGPACK_ENABLE_SHARED)
        SET_PROPERTY (TARGET msgpackc APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra -DPIC")
    ENDIF ()
    SET_PROPERTY (TARGET msgpackc-static APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra" )
ENDIF ()

IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
    IF (MSGPACK_ENABLE_SHARED)
        SET_PROPERTY (TARGET msgpackc APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
    ENDIF ()
    SET_PROPERTY (TARGET msgpackc-static APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
ENDIF ()

IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
    IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
        STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
    ELSE ()
        SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
    ENDIF ()
ENDIF ()

IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC90" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC10")
    SET_SOURCE_FILES_PROPERTIES(${msgpackc_SOURCES} PROPERTIES LANGUAGE CXX)
ENDIF ()

IF ("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "sparc")
    SET (CMAKE_C_FLAGS   "-DMSGPACK_ZONE_ALIGN=8 ${CMAKE_C_FLAGS}")
    SET (CMAKE_CXX_FLAGS "-DMSGPACK_ZONE_ALIGN=8 ${CMAKE_CXX_FLAGS}")
ENDIF ()

IF (NOT DEFINED CMAKE_INSTALL_BINDIR)
    SET(CMAKE_INSTALL_BINDIR bin)
ENDIF ()

IF (NOT DEFINED CMAKE_INSTALL_LIBDIR)
    SET(CMAKE_INSTALL_LIBDIR lib)
ENDIF ()

IF (MSGPACK_BUILD_EXAMPLES)
    ADD_SUBDIRECTORY (example)
ENDIF ()

IF (MSGPACK_ENABLE_SHARED)
    SET (MSGPACK_INSTALLTARGETS msgpackc msgpackc-static)
ELSE()
    SET (MSGPACK_INSTALLTARGETS msgpackc-static)
ENDIF ()

INSTALL (TARGETS ${MSGPACK_INSTALLTARGETS} EXPORT msgpack-targets
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)
FOREACH (file ${msgpackc_HEADERS})
    GET_FILENAME_COMPONENT (dir ${file} PATH)
    INSTALL (FILES ${file} DESTINATION ${CMAKE_INSTALL_PREFIX}/${dir})
ENDFOREACH ()
IF (NOT MSVC)
    INSTALL (FILES ${CMAKE_CURRENT_BINARY_DIR}/msgpack.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
ENDIF ()

# Doxygen
FIND_PACKAGE (Doxygen)
IF (DOXYGEN_FOUND)
    LIST (APPEND Doxyfile_c_CONTENT
        COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_c
        COMMAND ${CMAKE_COMMAND} -E echo "FILE_PATTERNS      = *.h" >> ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_c
        COMMAND ${CMAKE_COMMAND} -E echo "OUTPUT_DIRECTORY   = doc_c" >> ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_c
        COMMAND ${CMAKE_COMMAND} -E echo "INPUT              = ${CMAKE_CURRENT_SOURCE_DIR}/include" >> ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_c
        COMMAND ${CMAKE_COMMAND} -E echo "EXTRACT_ALL        = YES" >> ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_c
        COMMAND ${CMAKE_COMMAND} -E echo "PROJECT_NAME       = \"MessagePack for C\"" >> ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_c
    )
    IF (DOXYGEN_DOT_FOUND)
        LIST (APPEND Doxyfile_c_CONTENT
            COMMAND ${CMAKE_COMMAND} -E echo "HAVE_DOT       = YES" >> ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile_c
        )

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -63,6 +63,9 @@
         reference_wrapper_cpp11.cpp
         shared_ptr_cpp11.cpp
         unique_ptr_cpp11.cpp
+
+        # fuzzers are cpp11 only
+        fuzz_unpack_pack_fuzzer_cpp11.cpp
     )
 ENDIF ()
 
@@ -86,7 +89,7 @@
     )
     ADD_TEST (${source_file_we} ${source_file_we})
     IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS "-Wall -Wextra -Werror -g -O3 ")
+        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra")
     ENDIF ()
     IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
         SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")

=== example/boost/CMakeLists.txt ===
IF (MSGPACK_BOOST)
    LIST (APPEND exec_PROGRAMS
        msgpack_variant_capitalize.cpp
        msgpack_variant_mapbased.cpp
    )
    IF (MSGPACK_CXX11 OR MSGPACK_CXX17)
        FIND_PACKAGE (Threads REQUIRED)
        LIST (APPEND exec_PROGRAMS
            asio_send_recv.cpp
        )
        IF (ZLIB_FOUND)
            INCLUDE_DIRECTORIES (
                ${ZLIB_INCLUDE_DIRS}
            )
            LIST (APPEND exec_PROGRAMS
                asio_send_recv_zlib.cpp
            )
        ENDIF ()
    ENDIF ()
ENDIF ()

FOREACH (source_file ${exec_PROGRAMS})
    GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
    ADD_EXECUTABLE (
        ${source_file_we}
        ${source_file}
    )
    TARGET_INCLUDE_DIRECTORIES (${source_file_we}
        PRIVATE
            $<TARGET_PROPERTY:msgpackc,INTERFACE_INCLUDE_DIRECTORIES>
    )
    TARGET_LINK_LIBRARIES (${source_file_we}
        ${Boost_SYSTEM_LIBRARY}
        ${CMAKE_THREAD_LIBS_INIT}
    )
    IF (ZLIB_FOUND)
        TARGET_LINK_LIBRARIES (${source_file_we}
            ${ZLIB_LIBRARIES}
        )
    ENDIF()
    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra")
    ENDIF ()

    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
    ENDIF ()

    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
        IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
            STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        ELSE ()
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
        ENDIF ()
    ENDIF ()
ENDFOREACH ()

=== example/c/CMakeLists.txt ===
--- 
+++ 
@@ -23,7 +23,7 @@
         ${MSGPACK_LIB}
     )
     IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
-        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS "-Wall -Wextra -Werror -g -O3")
+        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra")
     ENDIF ()
 
     IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")

=== example/cpp03/CMakeLists.txt ===
LIST (APPEND exec_PROGRAMS
    class_intrusive.cpp
    class_intrusive_map.cpp
    class_non_intrusive.cpp
    custom.cpp
    enum.cpp
    map_based_versionup.cpp
    protocol_new.cpp
    reuse_zone.cpp
    simple.cpp
)

IF (MSGPACK_DEFAULT_API_VERSION EQUAL 1)
    LIST (APPEND exec_PROGRAMS
        protocol.cpp
    )
ENDIF ()

IF (NOT MSVC)
    LIST (APPEND with_pthread_PROGRAMS
        stream.cpp
    )
ENDIF ()

IF (MSGPACK_BOOST)
    LIST (APPEND with_boost_lib_PROGRAMS
        speed_test.cpp
        speed_test_nested_array.cpp
    )
ENDIF ()

FOREACH (source_file ${exec_PROGRAMS})
    GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
    ADD_EXECUTABLE (
        ${source_file_we}
        ${source_file}
    )
    TARGET_INCLUDE_DIRECTORIES (${source_file_we}
        PRIVATE
            $<TARGET_PROPERTY:msgpackc,INTERFACE_INCLUDE_DIRECTORIES>
    )
    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra")
    ENDIF ()
    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
        IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
            STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        ELSE ()
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
        ENDIF ()
    ENDIF ()
ENDFOREACH ()

FOREACH (source_file ${with_pthread_PROGRAMS})
    GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
    ADD_EXECUTABLE (
        ${source_file_we}
        ${source_file}
    )
    TARGET_INCLUDE_DIRECTORIES (${source_file_we}
        PRIVATE
            $<TARGET_PROPERTY:msgpackc,INTERFACE_INCLUDE_DIRECTORIES>
    )
    TARGET_LINK_LIBRARIES (${source_file_we}
        ${CMAKE_THREAD_LIBS_INIT}
    )
    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra")
    ENDIF ()
    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
        IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
            STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        ELSE ()
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
        ENDIF ()
    ENDIF ()
ENDFOREACH ()

FOREACH (source_file ${with_boost_lib_PROGRAMS})
    INCLUDE_DIRECTORIES (
        ../include
        ${Boost_INCLUDE_DIRS}
    )
    GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
    ADD_EXECUTABLE (
        ${source_file_we}
        ${source_file}
    )
    TARGET_INCLUDE_DIRECTORIES (${source_file_we}
        PRIVATE
            $<TARGET_PROPERTY:msgpackc,INTERFACE_INCLUDE_DIRECTORIES>
    )
    LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})
    TARGET_LINK_LIBRARIES (${source_file_we}
        ${Boost_TIMER_LIBRARY}
        ${Boost_CHRONO_LIBRARY}
        ${Boost_SYSTEM_LIBRARY}
    )
    IF (NOT MSVC AND NOT APPLE)
        TARGET_LINK_LIBRARIES (${source_file_we}
            rt
        )
    ENDIF ()

    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS "-Wall -Wextra -Werror -O3")
    ENDIF ()

    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
        SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
    ENDIF ()

    IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
        IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
            STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
        ELSE ()
            SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
        ENDIF ()
    ENDIF ()
ENDFOREACH ()

=== example/x3/CMakeLists.txt ===
IF (MSGPACK_USE_X3_PARSE AND MSGPACK_DEFAULT_API_VERSION VERSION_GREATER 1)
    INCLUDE_DIRECTORIES (
        ../include
    )

    LIST (APPEND exec_PROGRAMS
        unpack.cpp
        parse.cpp
    )
    IF (MSGPACK_BOOST)
        LIST (APPEND with_boost_PROGRAMS
            stream_unpack.cpp
        )
    ENDIF ()
    FOREACH (source_file ${exec_PROGRAMS})
        GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
        ADD_EXECUTABLE (
            ${source_file_we}
            ${source_file}
        )
        TARGET_INCLUDE_DIRECTORIES (${source_file_we}
            PRIVATE
                $<TARGET_PROPERTY:msgpackc,INTERFACE_INCLUDE_DIRECTORIES>
        )
        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
            SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra")
        ENDIF ()

        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
            SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
        ENDIF ()

        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
            IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
                STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
            ELSE ()
                SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
            ENDIF ()
        ENDIF ()
    ENDFOREACH ()
    FOREACH (source_file ${with_boost_PROGRAMS})
        GET_FILENAME_COMPONENT (source_file_we ${source_file} NAME_WE)
        ADD_EXECUTABLE (
            ${source_file_we}
            ${source_file}
        )
        TARGET_INCLUDE_DIRECTORIES (${source_file_we}
            PRIVATE
                $<TARGET_PROPERTY:msgpackc,INTERFACE_INCLUDE_DIRECTORIES>
        )
        TARGET_LINK_LIBRARIES (${source_file_we}
            ${Boost_CONTEXT_LIBRARY}
            ${Boost_SYSTEM_LIBRARY}
            ${CMAKE_THREAD_LIBS_INIT}
        )
        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang" OR "${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
            SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wall -Wextra")
        ENDIF ()

        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "Clang")
            SET_PROPERTY (TARGET ${source_file_we} APPEND_STRING PROPERTY COMPILE_FLAGS " -Wno-mismatched-tags")
        ENDIF ()

        IF ("${CMAKE_CXX_COMPILER_ID}" STREQUAL "MSVC")
            IF (CMAKE_CXX_FLAGS MATCHES "/W[0-4]")
                STRING(REGEX REPLACE "/W[0-4]" "/W3 /WX" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
            ELSE ()
                SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /W3 /WX")
            ENDIF ()
        ENDIF ()
    ENDFOREACH ()
ENDIF ()

=== debian/changelog ===
msgpack-c (3.0.1-3) unstable; urgency=medium

  * Use -DBUILD_GTEST=ON to be compatible with googletest < 1.8.1, which
    relied on gmock implicitly builing gtest

 -- James McCoy <jamessan@debian.org>  Sun, 28 Oct 2018 01:25:17 -0400

msgpack-c (3.0.1-2) unstable; urgency=medium

  * rules:
    + Do not fail build if build-gtest/ exists
    + Use -DBUILD_GMOCK=OFF to avoid building gmock, rather than trying to
      only build the googletest sub-directory (Closes: #912061)
    + Ensure dh_doxygen is called after dh_installdocs
  * Opt-in to debhelper 12 beta
  * Declare compliance with Policy 4.2.1, no changes needed
  * Add Build-Depends-Package to libmsgpackc2.symbols

 -- James McCoy <jamessan@debian.org>  Sat, 27 Oct 2018 23:57:16 -0400

msgpack-c (3.0.1-1) unstable; urgency=medium

  * New upstream release
  * Use cmake+ninja dh buildsystem
  * rules: Build googletest so tests can run

 -- James McCoy <jamessan@debian.org>  Sat, 12 May 2018 07:34:55 -0400

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,14 @@
 Maintainer: James McCoy <jamessan@debian.org>
 Build-Depends-Indep: doxygen,
                      doxygen-latex
-Build-Depends: cmake (>= 2.8.12),
-               debhelper (>= 11~),
-               googletest,
-               zlib1g-dev
-Standards-Version: 4.1.4
+Build-Depends:
+ cmake (>= 2.8.12),
+# 11.2.1~ needed for --buildsystem=cmake+ninja, 11.4~ for 12 beta
+ debhelper (>= 11.4~),
+ googletest,
+ ninja-build,
+ zlib1g-dev
+Standards-Version: 4.2.1
 Homepage: https://github.com/msgpack/msgpack-c/
 Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/jamessan/msgpack-c.git

=== debian/rules ===
--- 
+++ 
@@ -13,25 +13,28 @@
 export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
 
 %:
-	dh $@ --builddirectory=build
+	dh $@ --buildsystem=cmake+ninja --builddirectory=build
 
 override_dh_auto_configure:
-	env GTEST_ROOT=/usr/src/googletest/googletest dh_auto_configure -- -DMSGPACK_CXX11=ON -DMSGPACK_ENABLE_SHARED=ON -DMSGPACK_ENABLE_CXX=ON -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
+	mkdir -p build-gtest
+	cd build-gtest && \
+	  cmake -Wno-dev -DCMAKE_INSTALL_PREFIX=$(CURDIR)/build-gtest/install -DBUILD_GMOCK=OFF -DBUILD_GTEST=ON /usr/src/googletest && \
+	  make install
+endif
+	env GTEST_ROOT=$(CURDIR)/build-gtest/install dh_auto_configure -- -DMSGPACK_CXX11=ON -DMSGPACK_ENABLE_SHARED=ON -DMSGPACK_ENABLE_CXX=ON -DCMAKE_INSTALL_LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)
 
 override_dh_auto_build-indep:
 	dh_auto_build -- doxygen
 
 override_dh_install-indep:
 	dh_install -i
-	dh_doxygen
 
 override_dh_installdocs-indep:
 	mkdir -p build/html
 	mv build/doc_c/html build/html/msgpack-c
 	mv build/doc_cpp/html build/html/msgpack-cpp
 	dh_installdocs
+	dh_doxygen
 
 override_dh_auto_test-indep:
-
-override_dh_install:
-	dh_install --list-missing

=== debian/tests/control ===
Tests: c
Depends: @, build-essential, pkg-config

Tests: cpp03
Depends: @, build-essential

Tests: cpp11
Depends: @, build-essential

=== debian/watch ===
version=3

https://github.com/msgpack/msgpack-c/releases/ (?:.*/)?msgpack-([0-9.]+)\.tar\.gz
